/*
 * Sudoku program, amely a GDF részére diplomamunkául szolgál.
 * A programot írta: Pataki István, 2016-ban.
 */
package SudokuPIPkg.DataForms;

/**
 * Az osztály a program egy adatformáját testesíti meg.
 * A 3 területforma, a sor, az oszlop, a blokk közötti átjárhatóság
 * reprezentációja.
 */
public class DAPos extends DArea {

  /**
   * A területen belüli pozíció.
   */
  private byte offset;

  /**
   * Paraméterek nélküli konstruktor alapértékekkel való föltöltéshez.
   */
  public DAPos() {
    this(new DArea((byte) 0, (byte) 0, (byte) 0), (byte) 0);
  }

  /**
   * Részletes paraméterezettséggel ellátott konstruktor.
   * 
   * @param where
   * @param areaForm
   * @param area
   * @param offset 
   */
  public DAPos(byte where, byte areaForm, byte area, byte offset) {
    this(new DArea(where, areaForm, area), offset);
  }
  /**
   * DArea osztály segítségével tömörített konstruktor
   * 
   * @param area
   * @param offset 
   */
  public DAPos(DArea area, byte offset) {
    setValues(area, offset);
  }

  /**
   * DArea osztály segítségével tömörített értékadás
   * 
   * @param area
   * @param offset 
   */
  public void setValues(DArea area, byte offset) {
    this.setArea(area);
    this.offset = offset;   
  }

  /**
   * A területen belüli pozíció beállítását végző metódus
   * 
   * @param offset 
   */
  public void setOffset(byte offset) {
    this.offset = offset;
  }

  /**
   * Területen belüli pozíció visszaadása.
   * 
   * @return 
   */
  public byte getOffset() {
    return this.offset;
  }

  @Override
  public String toString() {
    return super.toString() + ", offset=" + offset;
  }

}
