package SudokuPIPkg.DataForms;

import SudokuPIPkg.Basis.IConst;
import java.awt.Color;

/**
 * Egy színkészletet összefogó osztály.
 */
public class DColors  implements IConst {

  private Color[] actColors = new Color[IConst.ELEMENTS_COUNT];

  /**
   * Bemásolja az aktuális színséma szineit
   * 
   * @param colors 
   */
  public void setColors(Color[] colors) {
    System.arraycopy(colors, 0, this.actColors, 0, ELEMENTS_COUNT);
    // sour => dest
  }

  /**
   * Visszaadja az aktuális színséma szineit
   * 
   * @return 
   */
  public Color[] getColors() {
    return actColors;
  }

  /**
   * Visszaadja az aktuális színséma adott színét.
   * 
   * @param element
   * @return 
   */
  public Color getColorElement(byte element) {
    return actColors[element];
  }

  /**
   * Beállítja az aktuális színséma adott színét.
   * 
   * @param element
   * @param color 
   */
  public void setColorElement(byte element, Color color) {
    actColors[element] = color;
  }

  @Override
  public String toString() {
    String result = "";
    for (byte c = 0; c < ELEMENTS_COUNT; c++) {
      result += ELEMENTS[c] + " = " + getColorElement(c).toString() + "\n";
    }
    return result;
  }

}
