/*
 * Szudoku program, amely a GDF részére diplomamunkámul szolgál
 * A programot írta: Pataki István, 2016-ban.
 */
package SudokuPIPkg.DataForms;

public class DNumber extends DWhere {

  /**
   * Lehetőség-érték vagy megoldás-érték vagy jelölt.
   */
  private byte number;

  /**
   * Paraméterek nélküli konstruktor alapértékekkel való föltöltéshez.
   */
  public DNumber() {
    this(new DWhere((byte) 0, new DCoord((byte) 0, (byte) 0)), (byte) 0);
  }

  /**
   * Paraméteres konstruktor adott értékek feltöltéséhez.
   * 
   * @param where
   * @param value 
   */
  public DNumber(DWhere where, byte value) {
    setValues(where, value);
  }

  /**
   * Adattagok feltöltése adott értékekkel.
   * 
   * @param where
   * @param value 
   */
  public void setValues(DWhere where, byte value) {
    this.setWhere(where);
    this.number = value;
  }

  /**
   * number adatag lekérdezése.
   * 
   * @return 
   */
  public byte getNumber() {
    return this.number;
  }

  /**
   * Number adattag beállítása.
   * 
   * @param number 
   */
  public void setNumber(DNumber number) {
    byte where = number.getWhere();
    DCoord coord = number.getCoord();
    setValues(new DWhere(where, coord), number.getNumber());
  }

  /**
   * adattag beálítása.
   * 
   * @param number 
   */
  public void setNumber(byte number) {
    this.number = number;
  }

  @Override
  public String toString() {
    return super.toString() + " " + this.number;
  }

}
