/*
 * Szudoku program, amely a GDF részére diplomamunkámul szolgál
 * A programot írta: Pataki István, 2016-ban.
 */
package SudokuPIPkg.DataForms;

import SudokuPIPkg.Basis.IConst;

public class DState extends DNumber {

  /**
   * érték állapot tárolója.
   */
  private boolean state;

  /**
   * Paraméterek nélküli konstruktor alapértékekkel való föltöltéshez.
   */
  public DState() {
    this(new DNumber(new DWhere((byte) 0, new DCoord((byte) 0, (byte) 0)), (byte) 0), true);
  }

  /**
   * A number és a state adattagnak ad értéket.
   * 
   * @param number
   * @param state 
   */
  public DState(DNumber number, boolean state) {
    setValues(number, state);
  }

  /**
   * A number és a state adattagnak ad értéket.
   * 
   * @param number
   * @param state 
   */
  public void setValues(DNumber number, boolean state) {
    this.setNumber(number);
    this.state = state;
  }

  /**
   * Lekérdezi a state adattagot.
   * 
   * @return 
   */
  public boolean getState() {
    return this.state;
  }

  /**
   * Beállítja astate hierarchiát.
   * 
   * @param state 
   */
  public void setState(DState state) {
    byte where = state.getWhere();
    DCoord coord = state.getCoord();
    byte number = state.getNumber();
    setValues(new DNumber(new DWhere(where, coord), number), state.getState());
  }

  /**
   * Beállítja a state adattagot
   * 
   * @param state 
   */
  public void setState(boolean state) {
    this.state = state;
  }

  @Override
  public String toString() {
    return super.toString() + " " + (this.getState() ? "ON" : "OFF");
  }

}
