/*
 * Szudoku program, amely a GDF részére diplomamunkámul szolgál
 * A programot írta: Pataki István, 2016-ban.
 */
package SudokuPIPkg.DataForms;

import SudokuPIPkg.Basis.IConst;

public class DWhere extends DCoord {

  /**
   * hol (OP_SCREEN - OP_MEMORY)
   */
  private byte where;

  /**
   * Paraméterek nélküli konstruktor alapértékekkel való föltöltéshez.
   */
  public DWhere() {
    this((byte) 0, new DCoord((byte) 0, (byte) 0));
  }

  /**
   * A hol és a koordináta adaattagnak ad értéket.
   * 
   * @param where hol (OP_SCREEN - OP_MEMORY)
   * @param coord row-col koordináta
   */
  public DWhere(byte where, DCoord coord) {
    setValues(where, coord);
  }

  /**
   * A hol és a koordináta adaattagnak ad értéket.
   * 
   * @param where hol (OP_SCREEN - OP_MEMORY)
   * @param coord row-col koordináta
   */
  public void setValues(byte where, DCoord coord) {
    this.where = where;
    this.setCoord(coord);
  }

  /**
   * Lekérdezi a hol adattagot.
   * 
   * @return 
   */
  public byte getWhere() {
    return this.where;
  }

  /**
   * Beállítja a hol és a pozíció adattagokat.
   * 
   * @param where hol + pozíció
   */
  public void setWhere(DWhere where) {
    setValues(where.getWhere(), where.getCoord());
  }

  /**
   * Beállítja a hol adattagot.
   * 
   * @param where hol (OP_SCREEN - OP_MEMORY)
   */
  public void setWhere(byte where) {
    this.where = where;
  }

  @Override
  public String toString() {
    String sWhere = (where == IConst.OP_SCREEN ? "Screen" : "Memory");
    return sWhere + " " + this.getCoord().toString();
  }

}
