/*
 * Szudoku program, amely a GDF részére diplomamunkámul szolgál
 * A programot írta: Pataki István, 2016-ban.
 */
package SudokuPIPkg;

import SudokuPIPkg.GUI.Frame;
import java.awt.BorderLayout;
import javax.swing.JFrame;
import javax.swing.JPanel;

public class SudokuPI extends JFrame {

  /**
   * A teljes felület tárolója.
   */
  private static final JPanel pSudoku = new JPanel();

  /**
   * Létrehozza a program fő objektumát, beállítja az ablakának paramétereit,
   * majd megjeleníti azt.
   *
   * @param args
   */
  public static void main(String[] args) {
    SudokuPI fSudoku = new SudokuPI();
    fSudoku.setDefaultCloseOperation(EXIT_ON_CLOSE);
    fSudoku.setTitle("Sudoku program v1.0, írta: Pataki István");
    fSudoku.setBounds(400, 100, 611, 716);
    fSudoku.setLocationRelativeTo(null);
    fSudoku.setResizable(false);
    fSudoku.setVisible(true);
  }

  /**
   * A program ablaka 3 fő konténerének elhelyezkedése (fő konstruktor).
   */
  private SudokuPI() {

    Frame myFrame;
    myFrame = new Frame();

    pSudoku.setLayout(new BorderLayout());
    /**
     * A fejléc elhelyezése, amin a menü és a toolbar található.
     */
    pSudoku.add(BorderLayout.PAGE_START, myFrame.pHead);
    /**
     * A lábléc elhelyezése, amin az információs sáv van elhelyezve.
     */
    pSudoku.add(BorderLayout.CENTER, myFrame.pGrid);
    /**
     * A főpanel hozzáadása a frame-hez.
     */
    pSudoku.add(BorderLayout.PAGE_END, myFrame.pFoot);
    /**
     * A középső, és egyben legnagyob terület, amin a játéktér foglal helyet.
     */
    add(pSudoku);
  }

  /**
   * A metódus visszaadja a pSudoku-ra mutató pointert annak érdekében,
   * hogy a főablakból megnyíló dialógus-ablakokat a főablak közepére
   * tudjam pozicionálni.
   * 
   * @return 
   */
  public static JPanel getpSudoku() {
    return pSudoku;
  }
}